﻿//Author:      night-king
// Email:       deepleo@163.com
//Home:       http://deepleo.com
//Github:     https://github.com/night-king/
//Date:         2013-11-1 
//Place:        Wuhan@China

using System;
using System.Collections.Generic;
using System.Text;

namespace Deepleo.LazyScheduler.Task
{
    public class LogTaskManager : ITaskManager
    {
        public LogTaskManager()
        {
            _highPriorityTask = new Queue<ITask>();
        }

        public void Init()
        {
            return;
        }

        private Queue<ITask> _highPriorityTask;

        public ITask Next()
        {
            if (_highPriorityTask.Count > 0)
            {
                return _highPriorityTask.Dequeue();
            }
            return new LogTask();
        }

        public void Append(List<ITask> tasks)
        {
            foreach (var t in tasks)
            {
                _highPriorityTask.Enqueue(t);
            }
        }
    }
}
